## holdingnuts 0.0.5

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (HOLDINGNUTS)

# switch features on/off
option (ENABLE_CLIENT	"Configure for client"		On)
option (ENABLE_AUDIO	"Configure client with audio"	On)
option (ENABLE_SERVER	"Configure for server"		On)
option (ENABLE_TEST	"Configure for test-utils"	Off)
option (ENABLE_DEBUG	"Configure for debug-build"	Off)

option (USE_SVNREV "Include the svn-revision in build" Off)
option (UPDATE_TRANSLATIONS "Update source translations" Off)
#OPTION(BUILD_DOCUMENTATION "Build the documentation (Doxygen)." OFF)   # this one is provided by CMake

################################################################################

# check for inner-source-build
STRING (COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" in_source)
IF (in_source)
	MESSAGE( "Inner-source-builds should not be used. For an outer-source-build create a separate build-directory and run cmake within it again.") 
ENDIF (in_source)

################################################################################

# Doxygen documentation
if (BUILD_DOCUMENTATION)
	add_subdirectory (doxygen)
endif (BUILD_DOCUMENTATION)

# the sources
add_subdirectory (src)

=== doxygen/CMakeLists.txt ===
include (Documentation)

#set (BUILD_DOXYGEN ON)
#set (DOCUMENTATION_HTML_TARZ ON)

set (DOXYFILE "Doxyfile")
set (DOXYGEN_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc)
set (DOXYGEN_STRIP_FROM_PATH ${HOLDINGNUTS_SOURCE_DIR})

set (DOXYGEN_INPUT
	"\"${HOLDINGNUTS_SOURCE_DIR}/src\" \\
	\"${HOLDINGNUTS_SOURCE_DIR}/src/libpoker\" \\
	\"${HOLDINGNUTS_SOURCE_DIR}/src/system\" \\
	\"${HOLDINGNUTS_SOURCE_DIR}/src/server\" \\
	\"${HOLDINGNUTS_SOURCE_DIR}/src/client\""
)

# fill placeholders in Doxyfile
configure_file (
    ${CMAKE_CURRENT_SOURCE_DIR}/${DOXYFILE}.in
    ${CMAKE_CURRENT_BINARY_DIR}/${DOXYFILE} @ONLY IMMEDIATE
)

add_custom_target (documentation
	COMMAND ${DOXYGEN_EXECUTABLE} \"${CMAKE_CURRENT_BINARY_DIR}/${DOXYFILE}\"
	COMMENT "Building doxygen documentation"
)

=== src/CMakeLists.txt ===
#determine platform we are building on/for
if (UNIX)
	set(PLATFORM_STR  "unix")
	add_definitions(-DPLATFORM_UNIX)
endif (UNIX)
if (WIN32)
	set(PLATFORM_STR  "win32")
	add_definitions(-DPLATFORM_WINDOWS)
endif (WIN32)
if (APPLE)
	set(PLATFORM_STR  "macosx")
	add_definitions(-DPLATFORM_MACOSX)
endif (APPLE)
IF (NOT PLATFORM_STR)
 set(PLATFORM_STR  "unix")
 MESSAGE("No target platform specified, using default (${PLATFORM_STR})")
 add_definitions(-DPLATFORM_UNIX)
ENDIF (NOT PLATFORM_STR)

#MESSAGE("Target platform is ${PLATFORM_STR}")

################################################################################

IF (WIN32)
IF (MINGW)
	#MESSAGE("using windres resource compiler")
	# http://sourceware.org/binutils/docs/binutils/windres.html
	FIND_PROGRAM(WINDRES NAMES windres i686-mingw32-windres)
ELSE (MINGW)
	MESSAGE("using rc resource compiler")
	# FIXME: find VC resource compiler
ENDIF (MINGW)
ENDIF (WIN32)

################################################################################

# gather information about svn-revision
IF (USE_SVNREV)
	FIND_PROGRAM(SVNVERSION NAMES svnversion)
	IF (SVNVERSION)
		EXEC_PROGRAM (${SVNVERSION} ARGS ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE REVISION)
		MESSAGE ("Using svn revision string: ${REVISION}")
		
		# DIRTY and dangerous workaround to determine if svnversion returned a revision;
		# svnversion always returns 0 as exit-code... so it's hard to find out
		STRING(LENGTH ${REVISION} revlen)
		IF (revlen LESS 6)    # localized string "exported"
			add_definitions(-DSVN_REV="${REVISION}")
		ENDIF (revlen LESS 6)
	ENDIF (SVNVERSION)
ENDIF (USE_SVNREV)


if (ENABLE_DEBUG OR CMAKE_BUILD_TYPE STREQUAL "Debug")
	add_definitions(-DDEBUG=1)
endif (ENABLE_DEBUG OR CMAKE_BUILD_TYPE STREQUAL "Debug")


# compiled in data-dir path
if (CMAKE_DATA_PATH)
	add_definitions(-DDATA_DIR=\"${CMAKE_DATA_PATH}/holdingnuts/data\")
	message ("Using data-dir ${CMAKE_DATA_PATH}/holdingnuts/data")
else (CMAKE_DATA_PATH)
	SET (CMAKE_DATA_PATH "${CMAKE_INSTALL_PREFIX}/share")
endif (CMAKE_DATA_PATH)


# additional definitions
add_definitions(-Wall)

# do not include RPATHs to our static libs in binaries
#set (CMAKE_BUILD_WITH_INSTALL_RPATH false)
set (CMAKE_SKIP_BUILD_RPATH true)


################################################################################

# libraries
add_subdirectory (libpoker)
add_subdirectory (system)

# the server
IF (ENABLE_SERVER)
	add_subdirectory (server)
ENDIF (ENABLE_SERVER)

# the client (depends on Qt4 and SDL)
IF (ENABLE_CLIENT)
	add_subdirectory (client)
ENDIF (ENABLE_CLIENT)

# test utils
IF (ENABLE_TEST)
	add_subdirectory (test)
ENDIF (ENABLE_TEST)

=== src/client/CMakeLists.txt ===
include_directories (
	${HOLDINGNUTS_SOURCE_DIR}/src
	${HOLDINGNUTS_SOURCE_DIR}/src/libpoker
	${HOLDINGNUTS_SOURCE_DIR}/src/system
	${HOLDINGNUTS_SOURCE_DIR}/src/server
	${HOLDINGNUTS_SOURCE_DIR}/src/client
)
link_directories(
	${HOLDINGNUTS_SOURCE_DIR}/src/libpoker
	${HOLDINGNUTS_SOURCE_DIR}/src/system
)

IF (WIN32)
	IF (MINGW)
		ADD_CUSTOM_COMMAND( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/pclient_res.obj
			COMMAND ${WINDRES}
			-I${CMAKE_CURRENT_SOURCE_DIR}
			-o ${CMAKE_CURRENT_BINARY_DIR}/pclient_res.obj
			< ${CMAKE_CURRENT_SOURCE_DIR}/pclient.rc
		)
		
		LIST(APPEND aux_obj pclient_res.obj)
	ELSE (MINGW)
		# FIXME: use VC resource compiler rc.exe
	ENDIF (MINGW)
ENDIF (WIN32)


# use SDL only for audio
if (ENABLE_AUDIO)
	Find_Package ( SDL REQUIRED )

	include_directories ( ${SDL_INCLUDE_DIR} )
	
	LIST (APPEND aux_src Audio.c)
	LIST (APPEND aux_lib ${SDL_LIBRARY})
else (ENABLE_AUDIO)
	add_definitions (-DNOAUDIO=1)
endif (ENABLE_AUDIO)

SET( QT_USE_QTNETWORK true )

Find_Package ( Qt4 REQUIRED )

# http://www.qtforum.org/article/26305/problem-running-configure-to-install-qt.html

INCLUDE(${QT_USE_FILE})


SET(QtApp_RCCS pclient.qrc)

QT4_ADD_RESOURCES(QtApp_RCC_SRCS ${QtApp_RCCS})

# Warning: older CMake versions (2.6-patch-0) do not provide moc-qt4 with preprocessor definitions
QT4_WRAP_CPP (
	sources_MOC
	pclient.hpp WMain.hpp SettingsDialog.hpp CreateGameDialog.hpp
	AboutDialog.hpp GameListTableModel.hpp PlayerListTableModel.hpp GameListSortFilterProxyModel.hpp
	WTable.hpp ChatBox.hpp DealerButton.hpp Seat.hpp EditableSlider.hpp TimeOut.hpp
)

add_executable (
	holdingnuts
	WIN32    # when building for windows: do not show the console window
	pclient.cpp ${aux_obj}
	WMain.cpp SettingsDialog.cpp CreateGameDialog.cpp AboutDialog.cpp
	GameListTableModel.cpp PlayerListTableModel.cpp GameListSortFilterProxyModel.cpp
	WTable.cpp ChatBox.cpp DealerButton.cpp Seat.cpp SeatImages.cpp EditableSlider.cpp TimeOut.cpp
	${aux_src}
	${sources_MOC} ${QtApp_RCC_SRCS}
)

target_link_libraries (
   holdingnuts
   Poker SysAccess System
   ${QT_LIBRARIES}
   ${aux_lib}
)

INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/holdingnuts DESTINATION
	${CMAKE_INSTALL_PREFIX}/bin)

############################################################

# data-directory
INSTALL(DIRECTORY ${HOLDINGNUTS_SOURCE_DIR}/data DESTINATION
	${CMAKE_DATA_PATH}/holdingnuts)

############################################################

# translations

#http://www.cmake.org/Wiki/CMake:How_To_Build_Qt4_Software
#http://doc.trolltech.com/4.3/i18n.html

file (GLOB TRANSLATIONS_FILES translations/*.ts)

file (GLOB SRC_FILES *.cpp *.hpp)
set (FILES_TO_TRANSLATE ${SRC_FILES})

if (UPDATE_TRANSLATIONS)
  qt4_create_translation(QM_FILES ${FILES_TO_TRANSLATE} ${TRANSLATIONS_FILES})
else (UPDATE_TRANSLATIONS)
  qt4_add_translation(QM_FILES ${TRANSLATIONS_FILES})
endif (UPDATE_TRANSLATIONS) 

add_custom_target (translations ALL DEPENDS ${QM_FILES})

install(FILES ${QM_FILES} DESTINATION	
	${CMAKE_DATA_PATH}/holdingnuts/data/i18n)

=== src/libpoker/CMakeLists.txt ===
include_directories (
	${HOLDINGNUTS_SOURCE_DIR}/src
	${HOLDINGNUTS_SOURCE_DIR}/src/libpoker
)

add_library(Poker
	GameDebug.cpp
	Card.cpp Deck.cpp HoleCards.cpp CommunityCards.cpp
	GameLogic.cpp
	Player.cpp
)

=== src/server/CMakeLists.txt ===
include_directories (
	${HOLDINGNUTS_SOURCE_DIR}/src
	${HOLDINGNUTS_SOURCE_DIR}/src/libpoker
	${HOLDINGNUTS_SOURCE_DIR}/src/system
	${HOLDINGNUTS_SOURCE_DIR}/src/server
)
link_directories(
	${HOLDINGNUTS_SOURCE_DIR}/src/libpoker
	${HOLDINGNUTS_SOURCE_DIR}/src/system
)

IF (WIN32)
	IF (MINGW)
		LIST(APPEND aux_lib ws2_32)
		
		ADD_CUSTOM_COMMAND( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/pserver_res.obj
			COMMAND ${WINDRES}
			-I${CMAKE_CURRENT_SOURCE_DIR}
			-o ${CMAKE_CURRENT_BINARY_DIR}/pserver_res.obj
			< ${CMAKE_CURRENT_SOURCE_DIR}/pserver.rc
		)
		LIST(APPEND aux_obj pserver_res.obj)
	ELSE (MINGW)
		LIST(APPEND aux_lib wsock32)
		
		# FIXME: use VC resource compiler rc.exe
	ENDIF (MINGW)
ENDIF (WIN32)


add_executable (holdingnuts-server
	pserver.cpp ${aux_obj}
	game.cpp GameController.cpp Table.cpp
)

target_link_libraries(holdingnuts-server
	Poker Network SysAccess System
	${aux_lib}
)

INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/holdingnuts-server DESTINATION
	        ${CMAKE_INSTALL_PREFIX}/bin)

=== src/system/CMakeLists.txt ===
include_directories (${HOLDINGNUTS_SOURCE_DIR}/src ${HOLDINGNUTS_SOURCE_DIR}/src/system)

add_library(Network Network.c)
add_library(SysAccess SysAccess.c)
add_library(System Tokenizer.cpp ConfigParser.cpp Logger.c)

=== src/test/CMakeLists.txt ===
include_directories (
	${HOLDINGNUTS_SOURCE_DIR}/src
	${HOLDINGNUTS_SOURCE_DIR}/src/libpoker
	${HOLDINGNUTS_SOURCE_DIR}/src/system
	${HOLDINGNUTS_SOURCE_DIR}/src/server
	${HOLDINGNUTS_SOURCE_DIR}/src/test
	
)
link_directories(
	${HOLDINGNUTS_SOURCE_DIR}/src/libpoker
	${HOLDINGNUTS_SOURCE_DIR}/src/system
)

add_executable (gc_test
	gc_test.cpp
	../server/GameController.cpp
	../server/Table.cpp
	TestCase.cpp
)
target_link_libraries(gc_test Poker System)

add_executable (test
	test.cpp
)
target_link_libraries(test Poker System)

add_executable (simulator simulator.cpp)
target_link_libraries(simulator Poker)

add_executable (systest system.cpp)
target_link_libraries(systest System SysAccess)

=== debian/changelog ===
holdingnuts (0.0.5-4) unstable; urgency=low

  * [92a4358b] Migrated from subversion to git on collab-maint
  * [a8ffc154] Leave patches unapplied locally
  * [e025b415] Switch to dh9, link --as-needed, build with hardening flags
  * [cab89346] Bump Standards-Version to 3.9.3

 -- Jan Hauke Rahm <jhr@debian.org>  Thu, 23 Feb 2012 13:22:37 +0100

holdingnuts (0.0.5-3) unstable; urgency=low

  * Let debhelper deal with parallel building
  * Take patch from upstream to fix a bug when calculating straight flushes
  * Bumped Standards-Version: 3.8.4

 -- Jan Hauke Rahm <jhr@debian.org>  Fri, 05 Mar 2010 14:21:24 +0100

holdingnuts (0.0.5-2) unstable; urgency=low

  * Reworked build system using dh's cmake capabilities
  * Suggest client for server and the other way round
  * Bumped Standards-Version: 3.8.3
  * Use DEP3 header for patches
  * Use source format 3.0 (quilt)

 -- Jan Hauke Rahm <jhr@debian.org>  Sun, 29 Nov 2009 10:43:04 +0100

holdingnuts (0.0.5-1) unstable; urgency=low

  * New upstream release
    + new translations: Russian, Italian
    + update display of pot after each bet:
      - summarize all pots and bets instead of showing single pots
      - detailed information about the pot is shown as tooltip window
    + workaround: set encoding to UTF-8; allows localized chat
    + improved re-connect feature (re-initialization on new round)
    + several bugfixes
  * debian/rules: use debhelper overrides as provided by debhelper >= 7.0.50
  * Bumped standards-version to 3.8.2: no changes

 -- Jan Hauke Rahm <info@jhr-online.de>  Fri, 26 Jun 2009 22:23:25 +0200

holdingnuts (0.0.4-1) unstable; urgency=low

  * New upstream release
    ** Note that both client and server are not compatible to prior versions
    + new option: bring table-window to top 
    + new translation: Japanese
    + new option: display time in foyer chat
    + new option: several verbosity levels for chat/log messages
    + support for restart-games (games which restart after they ended)
    + fixed client problem with bet-actions appearing
      + a second time after action was performed
      + when no more action was possible (e.g. all others allin)
    + added command-line option for specifying alternative config-directory 
      (this allows multiple server/client instances with independent config)
    + provide simple man-pages (which are used instead of those of the last
      Debian release)
  * debian/rules: support DEB_BUILD_OPTIONS
  * debian/patches: be FHS compliant

 -- Jan Hauke Rahm <info@jhr-online.de>  Thu, 04 Jun 2009 00:34:27 +0200

holdingnuts (0.0.3-1) unstable; urgency=low

  * Initial release (Closes: #525841)

 -- Jan Hauke Rahm <info@jhr-online.de>  Wed, 13 May 2009 09:43:51 +0200

=== debian/control ===
Source: holdingnuts
Section: games
Priority: extra
Maintainer: Jan Hauke Rahm <jhr@debian.org>
Build-Depends: debhelper (>= 9), cmake, qt4-qmake, libqt4-dev, libsdl-dev
Standards-Version: 3.9.3
Vcs-Git: git://git.debian.org/collab-maint/holdingnuts.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/holdingnuts.git;a=summary
Homepage: http://www.holdingnuts.net

Package: holdingnuts
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: holdingnuts-server
Description: poker client
 HoldingNuts is an open source multi-platform poker client and server.
 You can play the popular Texas Hold'em variant with people all over 
 the world, meet your friends, run your own games and even setup your 
 own poker network.
 .
 This package provides the client.

Package: holdingnuts-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: holdingnuts
Description: poker server
 HoldingNuts is an open source multi-platform poker client and server.
 You can play the popular Texas Hold'em variant with people all over 
 the world, meet your friends, run your own games and even setup your 
 own poker network.
 .
 This package provides the server.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS  = hardening=+bindnow,+pie
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,defs

# builddirectory constructed by dh
BDIR = "obj-$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)"

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_DATA_PATH=/usr/share/games \
		-DCMAKE_SKIP_RPATH=ON

override_dh_auto_install:
	$(MAKE) -C $(BDIR)/src/client DESTDIR=$(CURDIR)/debian/holdingnuts install
	$(MAKE) -C $(BDIR)/src/server DESTDIR=$(CURDIR)/debian/holdingnuts-server install

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# Uncomment to examine a Webpage
# <Webpage URL> <string match>
#http://www.example.com/downloads.php holdingnuts-(.*)\.tar\.gz

# Uncomment to examine a Webserver directory
#http://www.example.com/pub/holdingnuts-(.*)\.tar\.gz

# Uncommment to examine a FTP server
#ftp://ftp.example.com/pub/holdingnuts-(.*)\.tar\.gz debian uupdate

# Uncomment to find new files on sourceforge, for devscripts >= 2.9
http://sf.net/holdingnuts/holdingnuts-([0-9\.]+)\.tar\.bz2

# Uncomment to find new files on GooglePages
# http://example.googlepages.com/foo.html holdingnuts-(.*)\.tar\.gz
